<?php

/*********************************************************************

 新着ニュース表示プラグイン (2014/08/22)

  32877|http://32877.xii.jp

*********************************************************************/

/* メイン処理 */
function freo_display_news_recently()
{
	global $freo;

	if ($freo->config['plugin']['news_recently']['default_limit'] == 0) {
		return;
	}

	//検索条件設定
	$category_id = false;
		if ($freo->config['plugin']['news_recently']['category_id']) {
			$category_id = true;
		}

	if ($category_id == true){
		$condition = ' WHERE id IS NOT NULL AND category_id =:category_id';
	} else {
		$condition = ' WHERE id IS NOT NULL OR category_id =:category_id';
	}

	//ニュース取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_newses ' . $condition . ' ORDER BY datetime DESC LIMIT :limit');
	$stmt->bindValue(':limit', intval($freo->config['plugin']['news_recently']['default_limit']), PDO::PARAM_INT);
	$stmt->bindvalue(':category_id', $freo->config['plugin']['news_recently']['category_id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_newses = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_newses[$data['id']] = $data;
	}

	//ニュースID取得
	$plugin_news_keys = array_keys($plugin_newses);

	//ニュースタグ取得
	$plugin_news_tags = array();
	foreach ($plugin_news_keys as $plugin_news) {
		if (!$plugin_newses[$plugin_news]['tag']) {
			continue;
		}

		$plugin_news_tags[$plugin_news] = explode(',', $plugin_newses[$plugin_news]['tag']);
	}

	//ファイル取得
	$plugin_news_files = array();
	foreach ($plugin_news_keys as $plugin_news) {
		$file_dir = FREO_FILE_DIR . 'plugins/news_files/' . $plugin_news . '/';
		$thumbnail_dir = FREO_FILE_DIR . 'plugins/news_thumbnails/' . $plugin_news . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						list($width, $height, $size) = freo_file($file_dir . $data);
						if (is_file($thumbnail_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
							list($thumbnailwidth, $thumbnailheight, $thumbnailsize) = freo_file($thumbnail_dir . $data);
							$thumbnail = array(
								'name'    => $data,
								'width'   => $thumbnailwidth,
								'height'  => $thumbnailheight,
								'size'    => $thumbnailsize
							);
						} else {
							$thumbnail = array();
						}
						$plugin_news_files[$plugin_news][$matches[1]] = array(
							'name'      => $data,
							'width'     => $width,
							'height'    => $height,
							'size'      => $size,
							'thumbnail' => $thumbnail
						);
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'plugin_news_recentries'          => $plugin_newses,
		'plugin_news_recently_tags'       => $plugin_news_tags,
		'plugin_news_recently_files'      => $plugin_news_files
	));

	return;
}

?>
